IMPLEMENTATION MODULE CharClass;
  (* Copyright (C) 1989, Rowley Associates
                         32 Rowley
                         Cam
                         Dursley
                         Glos. GL11 5NT
                         England.

     RcsId: $Id: charclas.mod,v 1.1 90/12/10 13:00:26 paul Rel $

  *)

  IMPORT
    ASCII;

  VAR
    ch: CHAR;

  PROCEDURE Init(min, max: CHAR; class: ClassSet);
    VAR ch: CHAR;
  BEGIN
    FOR ch := min TO max DO
      ChTab[ch] := ChTab[ch] + class
    END
  END Init;

  PROCEDURE IsAlnum(ch: CHAR): BOOLEAN;
  BEGIN
    RETURN Alphanumeric IN ChTab[ch]
  END IsAlnum;

  PROCEDURE IsAlpha(ch: CHAR): BOOLEAN;
  BEGIN
    RETURN Alpha IN ChTab[ch]
  END IsAlpha;

  PROCEDURE IsAscii(ch: CHAR): BOOLEAN;
  BEGIN
    RETURN ch <= ASCII.DEL
  END IsAscii;

  PROCEDURE IsCntrl(ch: CHAR): BOOLEAN;
  BEGIN
    RETURN Control IN ChTab[ch]
  END IsCntrl;

  PROCEDURE IsDigit(ch: CHAR): BOOLEAN;
  BEGIN
    RETURN Digit IN ChTab[ch]
  END IsDigit;

  PROCEDURE IsLower(ch: CHAR): BOOLEAN;
  BEGIN
    RETURN Lowercase IN ChTab[ch]
  END IsLower;

  PROCEDURE IsPrint(ch: CHAR): BOOLEAN;
  BEGIN
    RETURN NOT (Control IN ChTab[ch])
  END IsPrint;

  PROCEDURE IsPunct(ch: CHAR): BOOLEAN;
  BEGIN
    RETURN ChTab[ch] * ClassSet{Alphanumeric, Control} = ClassSet{}
  END IsPunct;

  PROCEDURE IsUpper(ch: CHAR): BOOLEAN;
  BEGIN
    RETURN Uppercase IN ChTab[ch]
  END IsUpper;

  PROCEDURE IsSpace(ch: CHAR): BOOLEAN;
  BEGIN
    RETURN Whitespace IN ChTab[ch]
  END IsSpace;

  PROCEDURE IsXdigit(ch: CHAR): BOOLEAN;
  BEGIN
    RETURN HexDigit IN ChTab[ch]
  END IsXdigit;

  PROCEDURE ToUpper(ch: CHAR): CHAR;
  BEGIN
    RETURN CAP(ch)
  END ToUpper;

  PROCEDURE ToLower(ch: CHAR): CHAR;
  BEGIN
    IF Uppercase IN ChTab[ch] THEN
      RETURN CHR(ORD(ch) - ORD('A') + ORD('a'))
    ELSE
      RETURN ch
    END
  END ToLower;

BEGIN
  FOR ch := 40C TO MAX(CHAR) DO
    ChTab[ch] := ClassSet{}
  END;
  FOR ch := 0C TO 37C DO
    ChTab[ch] := ClassSet{Control}
  END;
  Init('A', 'Z', ClassSet{Uppercase, Alpha, Alphanumeric});
  Init('a', 'z', ClassSet{Lowercase, Alpha, Alphanumeric});
  Init('0', '9', ClassSet{Digit, HexDigit, Alphanumeric});
  Init('A', 'F', ClassSet{HexDigit});
  Init('a', 'f', ClassSet{HexDigit});
  INCL(ChTab[' '], Whitespace);
  INCL(ChTab[ASCII.FF], Whitespace);
  INCL(ChTab[ASCII.CR], Whitespace);
  INCL(ChTab[ASCII.HT], Whitespace);
  INCL(ChTab[ASCII.LF], Whitespace);
  INCL(ChTab[ASCII.EOL], Whitespace);
  INCL(ChTab[ASCII.DEL], Control);
END CharClass.
