IMPLEMENTATION MODULE Environment;
  (* Copyright (C) 1989, Rowley Associates
                         32 Rowley
                         Cam
                         Dursley
                         Glos. GL11 5NT
                         England.

     RcsId: $Id: environm.mod,v 1.2 91/09/14 13:32:53 paul Rel $

  *)

  FROM M2RTL IMPORT
    argc, argv, envp, ArgPtr;
  FROM Strings IMPORT
    Pos, Copy, Compare, Assign;

  PROCEDURE GetArg(    argn: INTEGER;
                   VAR val:  ARRAY OF CHAR;
                   VAR done: BOOLEAN);
  BEGIN
    IF argn >= argc THEN
      val[0] := 0C;
      done := FALSE;
    ELSE
      Assign(argv^[argn]^, val);
      done := TRUE
    END
  END GetArg;

  PROCEDURE GetEnv(    name: ARRAY OF CHAR;
                   VAR val:  ARRAY OF CHAR;
                   VAR done: BOOLEAN);
    VAR i, pos: CARDINAL;
        var: ARRAY [0..15] OF CHAR;
  BEGIN
    (* initialise *)
    i := 0; done := FALSE;

    (* search for environment variable *)
    WHILE NOT done & (envp^[i] # NIL) DO

      (* find position of '=' *)
      pos := Pos('=', envp^[i]^);

      (* extract environment variable's name *)
      Copy(envp^[i]^, 0, pos, var);

      (* see if we have a match *)
      IF Compare(var, name) = 0 THEN

        (* found match, extract value and exit loop *)
        Copy(envp^[i]^, pos+1, MAX(CARDINAL), val);
        done :=  TRUE
      ELSE

        (* not found, consider next environment variable *)
        INC(i)
      END
    END
  END GetEnv;

END Environment.

