IMPLEMENTATION MODULE InOut;
  (* Copyright (C) 1989, Rowley Associates
                         32 Rowley
                         Cam
                         Dursley
                         Glos. GL11 5NT
                         England.

     RcsId: $Id: inout.mod,v 1.3 91/05/12 21:12:39 paul Rel $

  *)

  (*$V- do not copy dynamic arrays *)

  FROM Strings IMPORT
    Length, Append;
  FROM ASCII IMPORT
    EOL;
  FROM Conversions IMPORT
    Oct, Dec, Hex;

  IMPORT
    FileSystem, Terminal, TextIO;

  PROCEDURE SetDone;
  BEGIN
    IF InFromFile THEN Done := TextIO.Done
    ELSE Done := Terminal.Done
    END
  END SetDone;

  PROCEDURE SettermCH;
  BEGIN
    IF InFromFile THEN termCH := TextIO.termCH
    ELSE termCH := Terminal.termCH
    END
  END SettermCH;

  PROCEDURE AddExt(VAR s: ARRAY OF CHAR; ext: ARRAY OF CHAR);
    VAR i, p: CARDINAL;
  BEGIN
    p := Length(s);
    i := 1;
    LOOP
      IF (i > p) OR (s[p-i] = '/') THEN
        Append(s, '.');
        Append(s, ext);
        EXIT
      END;
      IF s[p-i] = '.' THEN EXIT END;
      INC(i)
    END
  END AddExt;

  PROCEDURE OpenInput(defext: ARRAY OF CHAR);
    VAR name: ARRAY [0..79] OF CHAR;
  BEGIN
    CloseInput;
    Terminal.WriteString('in > ');
    Terminal.ReadLine(name);
    IF name[0] # 0C THEN
      AddExt(name, defext);
      OpenInputFile(name);
    ELSE
      Done := FALSE
    END
  END OpenInput;

  PROCEDURE OpenOutput(defext: ARRAY OF CHAR);
    VAR name: ARRAY [0..79] OF CHAR;
  BEGIN
    CloseOutput;
    Terminal.WriteString('out > ');
    Terminal.ReadLine(name);
    IF name[0] # 0C THEN
      AddExt(name, defext);
      OpenOutputFile(name);
    ELSE
      Done := FALSE
    END
  END OpenOutput;

  PROCEDURE OpenInputFile(name: ARRAY OF CHAR);
  BEGIN
    FileSystem.Lookup(InFile, name, FALSE);
    InFromFile := InFile.res = FileSystem.done
  END OpenInputFile;

  PROCEDURE OpenOutputFile(name: ARRAY OF CHAR);
  BEGIN
    FileSystem.Create(OutFile, name);
    OutToFile := OutFile.res = FileSystem.done;
  END OpenOutputFile;

  PROCEDURE CloseInput;
  BEGIN
    IF InFromFile THEN
      FileSystem.Close(InFile);
      InFromFile := FALSE
    END
  END CloseInput;

  PROCEDURE CloseOutput;
  BEGIN
    IF OutToFile THEN
      FileSystem.Close(OutFile);
      OutToFile := FALSE
    END
  END CloseOutput;

  PROCEDURE Read(VAR c: CHAR);
  BEGIN
    IF InFromFile THEN
      TextIO.Read(InFile, c)
    ELSE
      Terminal.Read(c)
    END;
    SetDone
  END Read;

  PROCEDURE ReadString(VAR str: ARRAY OF CHAR);
  BEGIN
    IF InFromFile THEN
      TextIO.ReadString(InFile, str)
    ELSE
      Terminal.ReadString(str)
    END;
    SettermCH; SetDone
  END ReadString;

  PROCEDURE ReadLine(VAR str: ARRAY OF CHAR);
  BEGIN
    IF InFromFile THEN
      TextIO.ReadLine(InFile, str)
    ELSE
      Terminal.ReadLine(str)
    END;
    SettermCH; SetDone
  END ReadLine;

  PROCEDURE ReadLn;
  BEGIN
    IF InFromFile THEN
      TextIO.ReadLn(InFile)
    ELSE
      Terminal.ReadLn
    END;
    SetDone
  END ReadLn;

  PROCEDURE ReadCard(VAR c: CARDINAL);
  BEGIN
    ReadCardBase(c, Dec)
  END ReadCard;

  PROCEDURE ReadOct(VAR c: CARDINAL);
  BEGIN
    ReadCardBase(c, Oct)
  END ReadOct;

  PROCEDURE ReadHex(VAR c: CARDINAL);
  BEGIN
    ReadCardBase(c, Hex)
  END ReadHex;

  PROCEDURE ReadInt(VAR i: INTEGER);
  BEGIN
    IF InFromFile THEN
      TextIO.ReadInt(InFile, i)
    ELSE
      Terminal.ReadInt(i)
    END;
    SettermCH; SetDone
  END ReadInt;

  PROCEDURE ReadCardBase(VAR c: CARDINAL; base: CARDINAL);
  BEGIN
    IF InFromFile THEN
      TextIO.ReadCardBase(InFile, c, base)
    ELSE
      Terminal.ReadCardBase(c, base)
    END;
    SettermCH; SetDone
  END ReadCardBase;

  PROCEDURE ReadLongCard(VAR c: LONGCARD);
  BEGIN
    ReadLongCardBase(c, Dec)
  END ReadLongCard;

  PROCEDURE ReadLongHex(VAR c: LONGCARD);
  BEGIN
    ReadLongCardBase(c, Hex)
  END ReadLongHex;

  PROCEDURE ReadLongOct(VAR c: LONGCARD);
  BEGIN
    ReadLongCardBase(c, Oct)
  END ReadLongOct;

  PROCEDURE ReadLongInt(VAR i: LONGINT);
  BEGIN
    IF InFromFile THEN
      TextIO.ReadLongInt(InFile, i)
    ELSE
      Terminal.ReadLongInt(i)
    END;
    SettermCH; SetDone
  END ReadLongInt;

  PROCEDURE ReadLongCardBase(VAR c: LONGCARD; base: CARDINAL);
  BEGIN
    IF InFromFile THEN
      TextIO.ReadLongCardBase(InFile, c, base)
    ELSE
      Terminal.ReadLongCardBase(c, base)
    END;
    SettermCH; SetDone
  END ReadLongCardBase;

  PROCEDURE Write(c: CHAR);
  BEGIN
    IF OutToFile THEN
      TextIO.Write(OutFile, c)
    ELSE
      Terminal.Write(c)
    END;
    SetDone
  END Write;

  PROCEDURE WriteLn;
  BEGIN
    Write(EOL);
  END WriteLn;

  PROCEDURE WriteString(str: ARRAY OF CHAR);
  BEGIN
    IF OutToFile THEN
      TextIO.WriteString(OutFile, str)
    ELSE
      Terminal.WriteString(str)
    END;
    SetDone
  END WriteString;

  PROCEDURE WriteStringRight(str: ARRAY OF CHAR; w: INTEGER);
  BEGIN
    IF OutToFile THEN
      TextIO.WriteStringRight(OutFile, str, w)
    ELSE
      Terminal.WriteStringRight(str, w)
    END;
    SetDone
  END WriteStringRight;

  PROCEDURE WriteCard(c: CARDINAL; w: INTEGER);
  BEGIN
    WriteLongCardBase(VAL(LONGCARD, c), w, Dec)
  END WriteCard;

  PROCEDURE WriteInt(i: INTEGER; w: INTEGER);
  BEGIN
    IF OutToFile THEN
      TextIO.WriteInt(OutFile, i, w)
    ELSE
      Terminal.WriteInt(i, w)
    END;
    SetDone
  END WriteInt;

  PROCEDURE WriteOct(c: CARDINAL; w: INTEGER);
  BEGIN
    WriteLongCardBase(VAL(LONGCARD, c), w, Oct)
  END WriteOct;

  PROCEDURE WriteHex(c: CARDINAL; w: INTEGER);
  BEGIN
    WriteLongCardBase(VAL(LONGCARD, c), w, Hex)
  END WriteHex;

  PROCEDURE WriteCardBase(c: CARDINAL; w: INTEGER; base: CARDINAL);
  BEGIN
    WriteLongCardBase(VAL(LONGCARD, c), w, base)
  END WriteCardBase;

  PROCEDURE WriteLongCard(c: LONGCARD; w: INTEGER);
  BEGIN
    WriteLongCardBase(c, w, Dec)
  END WriteLongCard;

  PROCEDURE WriteLongInt(i: LONGINT; w: INTEGER);
  BEGIN
    IF OutToFile THEN
      TextIO.WriteLongInt(OutFile, i, w)
    ELSE
      Terminal.WriteLongInt(i, w)
    END;
    SetDone
  END WriteLongInt;

  PROCEDURE WriteLongHex(c: LONGCARD; w: INTEGER);
  BEGIN
    WriteLongCardBase(c, w, Hex)
  END WriteLongHex;

  PROCEDURE WriteLongOct(c: LONGCARD; w: INTEGER);
  BEGIN
    WriteLongCardBase(c, w, Oct)
  END WriteLongOct;

  PROCEDURE WriteLongCardBase(c: LONGCARD; w: INTEGER; base: CARDINAL);
  BEGIN
    IF OutToFile THEN
      TextIO.WriteLongCardBase(OutFile, c, w, base)
    ELSE
      Terminal.WriteLongCardBase(c, w, base)
    END;
    SetDone
  END WriteLongCardBase;

BEGIN
  termCH := 0C;
  InFromFile := FALSE; OutToFile := FALSE;
  Done := FALSE
END InOut.
