/* Implementation of 64-bit complex division.

   Copyright (C) 1992, Rowley Associates
                       32 Rowley
                       Cam
                       Dursley
                       Glos. GL11 5NT
                       England.

   RcsId: $Id: m2_cdivd.c,v 1.2 92/07/30 21:13:01 paul Rel $

*/

#include "m2rtl.h"

void M2RTL_CDIVD(r, x, y)
COMPLEX *r, *x, *y;
{
    double ratio, den;
    double absre, absim;

    /* Compute absolute values of real and imaginary parts of divisor. */
    absre = y->re >= 0.0L ? y->re : -y->re;
    absim = y->im >= 0.0L ? y->im : -y->im;

    if (absre <= absim)
    {
        ratio = y->re / y->im;
        den = y->im * (1.0L + ratio*ratio);
        r->re = (x->re*ratio + x->im) / den;
        r->im = (x->im*ratio - x->re) / den;
    }
    else
    {
        ratio = y->im / y->re;
        den = y->re * (1.0L + ratio*ratio);
        r->re = (x->re + x->im*ratio) / den;
        r->im = (x->im - x->re*ratio) / den;
    }
}


