IMPLEMENTATION MODULE Terminal;
  (* Copyright (C) 1989, Rowley Associates
                         32 Rowley
                         Cam
                         Dursley
                         Glos. GL11 5NT
                         England.

     RcsId: $Id: terminal.mod,v 1.3 91/05/12 20:58:46 paul Rel $

  *)

  (*$V- do not copy dynamic arrays *)

  FROM ASCII IMPORT
    EOL;
  FROM Conversions IMPORT
    ConvertToString, ConvertToNumber, DecimalToInteger, DecimalToLongint,
    Oct, Dec, Hex, SignType;
  FROM Strings IMPORT
    Length;

  IMPORT
    Termbase;

  PROCEDURE KeyPressed(): BOOLEAN;
  BEGIN
    RETURN Termbase.KeyPressed()
  END KeyPressed;

  PROCEDURE Read(VAR ch: CHAR);
  BEGIN
    Termbase.Read(ch, Done)
  END Read;

  PROCEDURE ReadString(VAR str: ARRAY OF CHAR);
  BEGIN
    Termbase.ReadString(str, Done);
    termCH := Termbase.termCH
  END ReadString;

  PROCEDURE ReadLine(VAR str: ARRAY OF CHAR);
  BEGIN
    Termbase.ReadLine(str, Done);
    termCH := Termbase.termCH
  END ReadLine;

  PROCEDURE ReadLn;
    VAR ch: CHAR;
  BEGIN
    Read(ch);
    WHILE Done & (ch # EOL) DO
      Read(ch)
    END
  END ReadLn;

  PROCEDURE ReadCard(VAR c: CARDINAL);
  BEGIN
    ReadCardBase(c, Dec)
  END ReadCard;

  PROCEDURE ReadInt(VAR i: INTEGER);
    VAR str: ARRAY [0..79] OF CHAR;
  BEGIN
    ReadLine(str);
    IF Done THEN
      DecimalToInteger(str, i, Done)
    END
  END ReadInt;

  PROCEDURE ReadHex(VAR c: CARDINAL);
  BEGIN
    ReadCardBase(c, Hex)
  END ReadHex;

  PROCEDURE ReadOct(VAR c: CARDINAL);
  BEGIN
    ReadCardBase(c, Oct)
  END ReadOct;

  PROCEDURE ReadCardBase(VAR c: CARDINAL; base: CARDINAL);
    VAR str: ARRAY [0..79] OF CHAR;
        l: LONGCARD;
  BEGIN
    ReadLine(str);
    IF Done THEN
      ConvertToNumber(str, base, FALSE, MAX(CARDINAL), l, Done);
      IF Done THEN
        c := VAL(CARDINAL, l)
      END
    END
  END ReadCardBase;

  PROCEDURE ReadLongCard(VAR c: LONGCARD);
  BEGIN
    ReadLongCardBase(c, Dec)
  END ReadLongCard;

  PROCEDURE ReadLongInt(VAR i: LONGINT);
    VAR str: ARRAY [0..79] OF CHAR;
  BEGIN
    ReadLine(str);
    IF Done THEN
      DecimalToLongint(str, i, Done)
    END
  END ReadLongInt;

  PROCEDURE ReadLongHex(VAR c: LONGCARD);
  BEGIN
    ReadLongCardBase(c, Hex)
  END ReadLongHex;

  PROCEDURE ReadLongOct(VAR c: LONGCARD);
  BEGIN
    ReadLongCardBase(c, Oct)
  END ReadLongOct;

  PROCEDURE ReadLongCardBase(VAR c: LONGCARD; base: CARDINAL);
    VAR str: ARRAY [0..79] OF CHAR;
  BEGIN
    ReadLine(str);
    IF Done THEN
      ConvertToNumber(str, base, FALSE, MAX(LONGCARD), c, Done);
    END
  END ReadLongCardBase;

  PROCEDURE Write(ch: CHAR);
  BEGIN
    Termbase.Write(ch)
  END Write;

  PROCEDURE WriteLn;
  BEGIN
    Termbase.Write(EOL)
  END WriteLn;

  PROCEDURE WriteString(str: ARRAY OF CHAR);
  BEGIN
    Termbase.WriteString(str)
  END WriteString;

  PROCEDURE WriteStringRight(str: ARRAY OF CHAR; w: INTEGER);
    VAR l: INTEGER;

    PROCEDURE WriteBlanks(l, w: INTEGER);
      VAR blanks: ARRAY [0..39] OF CHAR;
          i: INTEGER;
    BEGIN
      IF l < w THEN
        FOR i := 0 TO HIGH(blanks) DO blanks[i] := ' ' END;
        FOR i := 1 TO (w-l) DIV SIZE(blanks) DO
          Termbase.WriteString(blanks)
        END;
        blanks[(w-l) MOD SIZE(blanks)] := 0C;
        Termbase.WriteString(blanks)
      END
    END WriteBlanks;

  BEGIN
    l := Length(str);
    IF w > 0 THEN
      WriteBlanks(l, w)
    END;
    Termbase.WriteString(str);
    IF w < 0 THEN
      WriteBlanks(l, -w)
    END
  END WriteStringRight;

  PROCEDURE WriteCard(c: CARDINAL; l: INTEGER);
  BEGIN
    WriteLongCardBase(VAL(LONGCARD, c), l, Dec)
  END WriteCard;

  PROCEDURE WriteInt(i: INTEGER; l: INTEGER);
  BEGIN
    WriteLongInt(VAL(LONGINT, i), l)
  END WriteInt;

  PROCEDURE WriteOct(c: CARDINAL; l: INTEGER);
  BEGIN
    WriteLongCardBase(VAL(LONGCARD, c), l, Oct)
  END WriteOct;

  PROCEDURE WriteHex(c: CARDINAL; l: INTEGER);
  BEGIN
    WriteLongCardBase(VAL(LONGCARD, c), l,  Hex)
  END WriteHex;

  PROCEDURE WriteCardBase(c: CARDINAL; w: INTEGER; base: CARDINAL);
  BEGIN
    WriteLongCardBase(VAL(LONGCARD, c), w, base);
  END WriteCardBase;

  PROCEDURE WriteLongCard(c: LONGCARD; l: INTEGER);
  BEGIN
     WriteLongCardBase(c, l, Dec)
  END WriteLongCard;

  PROCEDURE WriteLongInt(i: LONGINT; w: INTEGER);
    VAR str: ARRAY [0..19] OF CHAR;
  BEGIN
    IF i < 0 THEN
      ConvertToString(ABS(i), 1, Dec, minus, str)
    ELSE
      ConvertToString(i, 1, Dec, space, str)
    END;
    WriteStringRight(str, w)
  END WriteLongInt;

  PROCEDURE WriteLongOct(c: LONGCARD; l: INTEGER);
  BEGIN
    WriteLongCardBase(c, l, Oct)
  END WriteLongOct;

  PROCEDURE WriteLongHex(c: LONGCARD; l: INTEGER);
  BEGIN
    WriteLongCardBase(c, l, Hex)
  END WriteLongHex;

  PROCEDURE WriteLongCardBase(c: LONGCARD; w: INTEGER; base: CARDINAL);
    VAR str: ARRAY [0..19] OF CHAR;
  BEGIN
    ConvertToString(c, 1, base, none, str);
    WriteStringRight(str, w);
  END WriteLongCardBase;

END Terminal.
