IMPLEMENTATION MODULE TextIO;
  (* Copyright (C) 1989, Rowley Associates
                         32 Rowley
                         Cam
                         Dursley
                         Glos. GL11 5NT
                         England.

     RcsId: $Id: textio.mod,v 1.2 91/04/07 13:33:17 paul Rel $

  *)

  FROM Conversions IMPORT
    ConvertToString, ConvertToNumber, DecimalToInteger, DecimalToLongint,
    Oct, Dec, Hex, SignType;
  FROM CharClass IMPORT
    IsCntrl;
  FROM Strings IMPORT
    Length;
  FROM ASCII IMPORT
    EOL;

  (*$V-*)

  IMPORT
    FileSystem;

  PROCEDURE Read(VAR f: File;
                 VAR c: CHAR);
  BEGIN
    FileSystem.ReadChar(f, c);
    Done := (f.res = FileSystem.done)
  END Read;

  PROCEDURE ReadString(VAR f:   File;
                       VAR str: ARRAY OF CHAR);
    VAR i: CARDINAL;
  BEGIN
    i := 0;
    LOOP
      IF (i > HIGH(str)) OR (f.res # FileSystem.done) THEN EXIT END;
      FileSystem.ReadChar(f, termCH);
      str[i] := termCH;
      IF IsCntrl(termCH) THEN EXIT END;
      INC(i)
    END;
    IF i <= HIGH(str) THEN str[i] := 0C END;
    Done := (f.res = FileSystem.done)
  END ReadString;

  PROCEDURE ReadLine(VAR f:   File;
                     VAR str: ARRAY OF CHAR);
  BEGIN
    FileSystem.ReadLine(f, str);
    termCH := EOL;
    Done := (f.res = FileSystem.done)
  END ReadLine;

  PROCEDURE ReadLn(VAR f: File);
  BEGIN
    FileSystem.ReadLn(f);
    Done := (f.res = FileSystem.done)
  END ReadLn;

  PROCEDURE ReadCard(VAR f: File;
                     VAR c: CARDINAL);
  BEGIN
    ReadCardBase(f, c, Dec)
  END ReadCard;

  PROCEDURE ReadOct(VAR f: File;
                    VAR c: CARDINAL);
  BEGIN
    ReadCardBase(f, c, Oct)
  END ReadOct;

  PROCEDURE ReadHex(VAR f: File;
                    VAR c: CARDINAL);
  BEGIN
    ReadCardBase(f, c, Hex)
  END ReadHex;

  PROCEDURE ReadInt(VAR f: File;
                    VAR i: INTEGER);
    VAR str: ARRAY [0..79] OF CHAR;
  BEGIN
    ReadString(f, str);
    IF f.res = FileSystem.done THEN
      DecimalToInteger(str, i, Done)
    ELSE
      Done := FALSE
    END
  END ReadInt;

  PROCEDURE ReadCardBase(VAR f:    File;
                         VAR c:    CARDINAL;
                             base: CARDINAL);
    VAR str: ARRAY [0..79] OF CHAR;
        l: LONGCARD;
  BEGIN
    ReadString(f, str);
    IF f.res = FileSystem.done THEN
      ConvertToNumber(str, base, FALSE, MAX(CARDINAL), l, Done);
      IF Done THEN
        c := VAL(CARDINAL, l)
      END
    ELSE
      Done := FALSE
    END
  END ReadCardBase;

  PROCEDURE ReadLongCard(VAR f: File;
                         VAR c: LONGCARD);
  BEGIN
    ReadLongCardBase(f, c, Dec)
  END ReadLongCard;

  PROCEDURE ReadLongOct(VAR f: File;
                        VAR c: LONGCARD);
  BEGIN
    ReadLongCardBase(f, c, Oct)
  END ReadLongOct;

  PROCEDURE ReadLongHex(VAR f: File;
                        VAR c: LONGCARD);
  BEGIN
    ReadLongCardBase(f, c, Hex)
  END ReadLongHex;

  PROCEDURE ReadLongInt(VAR f: File;
                        VAR i: LONGINT);
    VAR str: ARRAY [0..79] OF CHAR;
  BEGIN
    ReadString(f, str);
    IF f.res = FileSystem.done THEN
      DecimalToLongint(str, i, Done)
    ELSE
      Done := FALSE
    END
  END ReadLongInt;

  PROCEDURE ReadLongCardBase(VAR f:    File;
                             VAR c:    LONGCARD;
                                 base: CARDINAL);
    VAR str: ARRAY [0..79] OF CHAR;
  BEGIN
    ReadString(f, str);
    IF f.res = FileSystem.done THEN
      ConvertToNumber(str, base, FALSE, MAX(LONGCARD), c, Done);
    ELSE
      Done := FALSE
    END
  END ReadLongCardBase;

  PROCEDURE Write(VAR f: File;
                      c: CHAR);
  BEGIN
    FileSystem.WriteChar(f, c);
    Done := (f.res = FileSystem.done)
  END Write;

  PROCEDURE WriteLn(VAR f: File);
  BEGIN
    Write(f, EOL);
    Done := (f.res = FileSystem.done)
  END WriteLn;

  PROCEDURE WriteString(VAR f:   File;
                            str: ARRAY OF CHAR);
    VAR i: CARDINAL;
  BEGIN
    i := 0;
    WHILE (f.res = FileSystem.done) & (i <= HIGH(str)) & (str[i] # 0C) DO
      Write(f, str[i]); INC(i)
    END;
    Done := (f.res = FileSystem.done)
  END WriteString;

  PROCEDURE WriteStringRight(VAR f:   File;
                                 str: ARRAY OF CHAR;
                                 w:   INTEGER);
    VAR l: INTEGER;
  BEGIN
    l := Length(str);
    IF w > 0 THEN
      WHILE l < w DO Write(f, ' '); INC(l) END;
    END;
    WriteString(f, str);
    IF w < 0 THEN
      WHILE l < -w DO Write(f, ' '); INC(l) END;
    END;
    Done := (f.res = FileSystem.done)
  END WriteStringRight;

  PROCEDURE WriteCard(VAR f: File;
                          c: CARDINAL;
                          l: INTEGER);
  BEGIN
    WriteLongCardBase(f, VAL(LONGCARD, c), l, Dec)
  END WriteCard;

  PROCEDURE WriteInt(VAR f: File;
                         i: INTEGER;
                         l: INTEGER);
  BEGIN
    WriteLongInt(f, VAL(LONGINT, i), l)
  END WriteInt;

  PROCEDURE WriteOct(VAR f: File;
                         c: CARDINAL;
                         l: INTEGER);
  BEGIN
    WriteLongCardBase(f, VAL(LONGCARD, c), l, Oct)
  END WriteOct;

  PROCEDURE WriteHex(VAR f: File;
                         c: CARDINAL;
                         l: INTEGER);
  BEGIN
    WriteLongCardBase(f, VAL(LONGCARD, c), l, Hex)
  END WriteHex;

  PROCEDURE WriteCardBase(VAR f:    File;
                              c:    CARDINAL;
                              l:    INTEGER;
                              base: CARDINAL);
  BEGIN
    WriteLongCardBase(f, VAL(LONGCARD, c), l, base)
  END WriteCardBase;

  PROCEDURE WriteLongCard(VAR f: File;
                              c: LONGCARD;
                              l: INTEGER);
  BEGIN
    WriteLongCardBase(f, c, l, Dec)
  END WriteLongCard;

  PROCEDURE WriteLongInt(VAR f: File;
                             i: LONGINT;
                             l: INTEGER);
    VAR str: ARRAY [0..19] OF CHAR;
  BEGIN
    IF i < 0 THEN
      ConvertToString(ABS(i), 1, Dec, minus, str)
    ELSE
      ConvertToString(i, 1, Dec, space, str)
    END;
    WriteStringRight(f, str, l);
  END WriteLongInt;

  PROCEDURE WriteLongOct(VAR f: File;
                             c: LONGCARD;
                             l: INTEGER);
  BEGIN
    WriteLongCardBase(f, c, l, Oct)
  END WriteLongOct;

  PROCEDURE WriteLongHex(VAR f: File;
                             c: LONGCARD;
                             l: INTEGER);
  BEGIN
    WriteLongCardBase(f, c, l, Hex)
  END WriteLongHex;

  PROCEDURE WriteLongCardBase(VAR f:    File;
                                  c:    LONGCARD;
                                  l:    INTEGER;
                                  base: CARDINAL);
    VAR str: ARRAY [0..19] OF CHAR;
  BEGIN
    ConvertToString(c, 1, base, none, str);
    WriteStringRight(f, str, l);
  END WriteLongCardBase;

END TextIO.
